<?xml version="1.0"?>
<odoo>
<data>

<!-- should be fix to actually add the attachement -->
<record id="agepoly_account_move_upload_attachement" model="ir.actions.client">
    <field name="name">Upload Attachements</field>
    <field name="tag">agepoly_account_move_upload_attachement</field>
</record>

<record id="account.action_move_in_invoice_type" model="ir.actions.act_window">
    <field name="context" eval="
        {
            'default_move_type': 'in_invoice',
            'default_journal_id': ref('bill_journal'),
            'default_payment_mode_id': ref('agepoly_payment_mode_bank_out')
        }
    "/>
</record>

<record id="agepoly_account_move_form_view_ihnerit" model="ir.ui.view">      
        <field name="name">agepoly.account.move.form</field>
        <field name="priority">100</field>
        <field name="model">account.move</field>
        <field name="inherit_id" ref="account.view_move_form"/>
        <field name="arch" type="xml">
            <!-- warning when bank account is not set -->
            
            <header position="after">
                <div
                    class="alert alert-warning"
                    role="alert"
                    style="margin-bottom:0px;"
                    attrs="{
                            'invisible': 
                                ['|','|',
                                    ('payment_mode_id', '!=', %(agepoly_payment_mode_bank_out)d),
                                    ('partner_bank_id', '!=', False),
                                    ('journal_id', '=', %(ndf_journal)d)
                                ]
                            }"
                >
                    <p><i class="fa fa-info-circle" /> A bank account must be set up to pay the vendor
                    </p>
                </div>
                <div
                    class="alert alert-warning"
                    role="alert"
                    style="margin-bottom:0px;"
                    attrs="{
                            'invisible': 
                                ['|','|', 
                                  ('payment_mode_id', '!=', %(agepoly_payment_mode_bank_out)d),
                                  ('partner_bank_id', '!=', False),
                                  ('journal_id', '!=', %(ndf_journal)d)
                                ]
                            }"
                >
                    <p><i class="fa fa-info-circle" /> The beneficiary must define a bank account in his profile
                    </p>
                </div>
            </header>

            <!--<xpath expr="//button[@name='action_post']" position="after">
                <button name="%(agepoly_account_move_upload_attachement)d" string="Uploader un Justificatif" class="oe_highlight o_AttachmentBox_buttonAdd"
                                type="action"/>
            </xpath>-->

            <!-- Change -->
            <xpath expr="//label[@for='ref']" position="attributes">
                <attribute name="attrs">{}</attribute>
                <attribute name="string">Title</attribute>
            </xpath>
            <xpath expr="//field[@name='ref']" position="attributes">
                <attribute name="attrs">{}</attribute>
            </xpath>

            <!-- remove groups condition on journal field and label -->
            <xpath expr="//label[@for='journal_id']" position="attributes">
                <attribute name="groups"></attribute>
            </xpath>
            <xpath expr="//field[@name='journal_id']" position="attributes">
                <attribute name="groups"></attribute>
            </xpath>

            <!-- remove various groups requirements -->
            <xpath expr="//field[@name='account_id']" position="attributes">
                <attribute name="groups"></attribute>
            </xpath>
            <xpath expr="//field[@name='product_uom_id']" position="attributes">
                <attribute name="groups"></attribute>
            </xpath>

            <!-- auto_post only for accountant -->
            <xpath expr="//field[@name='auto_post']" position="attributes">
                <attribute name="groups">account.group_account_invoice</attribute>
            </xpath>
           
            <xpath expr="//field[@name='payment_reference']" position="attributes">
                <attribute name="attrs">
                    {
                        'invisible': 
                            ['|', 
                                ['move_type', 'not in', ['out_invoice', 'out_refund', 'in_invoice', 'in_refund', 'out_receipt', 'in_receipt']],
                                '&amp;', 
                                ['move_type', 'in', ['out_invoice']], 
                                ['payment_reference', '=', False]
                            ], 
                        'readonly': 
                            ['|', 
                                ['move_type', 'in', ['out_invoice']],
                                '&amp;',
                                ['payment_state', '!=', 'not_paid'],
                                ['move_type', 'in', ['in_invoice', 'out_refund', 'in_receipt']]
                            ]
                    }
                </attribute>
            </xpath>
            <xpath expr="//group[@id='header_right_group']" position="inside">
                <field name="show_linked_request_in_form" invisible="1"/>
                <field  
                        name="money_requests_ids" 
                        widget="many2many_tags"
                        attrs="{'invisible': [('show_linked_request_in_form', '=', False)]}"
                        options="{'no_create': True}"
                />
            </xpath>

            <!-- readonly journal items except if context or user group advanced TOCHECK context -->
            <xpath expr="//field[@name='line_ids']" position="attributes">
                <attribute name="attrs" eval="
                    { 
                        'readonly': False if context.get('allow_advanced_accounting', False) != False else [['has_agepoly_advanced_account_user_group', '!=', True]]
                    }
                "/>
            </xpath>

            <xpath expr="//field[@name='invoice_line_ids']/tree/field[@name='analytic_account_id']" position="attributes">      
                <attribute name="groups"></attribute>
                <attribute name="options">{'no_create': True}</attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/form/sheet/group/field[@name='analytic_account_id']" position="attributes">      
                <attribute name="groups"></attribute>            
                <attribute name="options">{'no_create': True}</attribute>
            </xpath>

            <xpath expr="//field[@name='invoice_line_ids']/tree/field[@name='analytic_tag_ids']" position="attributes">
                <attribute name="groups"></attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/form/sheet/group/field[@name='analytic_tag_ids']" position="attributes">
                <attribute name="groups"></attribute>
            </xpath>
        </field>
    </record>

    <record id="agepoly_account_operating_unit_view_move_form_ihnerit" model="ir.ui.view">      
        <field name="name">agepoly.account_operating_unit.move.form</field>
        <field name="model">account.move</field>
        <field name="inherit_id" ref="account_operating_unit.view_move_form"/>
        <field name="arch" type="xml">
            <!-- set the default analytic_account on move line depending on OU and OU default analytic (see models/account_move.py) -->
            <xpath expr="//field[@name='invoice_line_ids']/tree//field[@name='account_id']" position="after">
                <field name="operating_unit_id" invisible="1"/>
                <field name="operating_unit_id" options="{'no_create': True}" optional="show" groups="agepoly_account_customizations.agepoly_advanced_accounting_menu,agepoly_account_customizations.agepoly_account_accountant"/>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/form/sheet/group/field[@name='account_id']" position="after">
                <field name="operating_unit_id" invisible="1"/>
                <field name="operating_unit_id" options="{'no_create': True}" optional="show" groups="agepoly_account_customizations.agepoly_advanced_accounting_menu,agepoly_account_customizations.agepoly_account_accountant"/>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/tree//field[@name='analytic_account_id']" position="attributes">
                <attribute name="domain">
                    ['|', ('company_id', '=', False), ('company_id', '=',
                    parent.company_id), '|', ('operating_unit_ids', '=', operating_unit_id), ('operating_unit_ids', '=', False)]
                </attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/form/sheet/group/field[@name='analytic_account_id']" position="attributes">
                <attribute name="domain">
                    ['|', ('company_id', '=', False), ('company_id', '=',
                    parent.company_id), '|', ('operating_unit_ids', '=', operating_unit_id), ('operating_unit_ids', '=', False)]
                </attribute>
            </xpath>

            <xpath expr="//field[@name='invoice_line_ids']/tree/field[@name='product_id']" position="attributes">
                <attribute name="optional">
                    "hide"
                </attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/tree/field[@name='quantity']" position="attributes">
                <attribute name="optional">
                    "hide"
                </attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/tree/field[@name='analytic_tag_ids']" position="attributes">
                <attribute name="optional">
                    "hide"
                </attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']/tree/field[@name='product_uom_id']" position="attributes">
                <attribute name="optional">
                    "hide"
                </attribute>
            </xpath>

            <xpath expr="//field[@name='line_ids']/tree//field[@name='analytic_account_id']" position="attributes">
                <attribute name="domain">
                    ['|', ('company_id', '=', parent.company_id), ('company_id', '=',
                    False), '|', ('operating_unit_ids', '=', operating_unit_id), ('operating_unit_ids', '=', False)]
                </attribute>
            </xpath>

            <xpath expr="//field[@name='line_ids']/form/group/field[@name='account_id']" position="after">
                <field name="operating_unit_id" invisible="1"/>
                <field name="operating_unit_id" options="{'no_create': True}" optional="show" groups="agepoly_account_customizations.agepoly_advanced_accounting_menu,agepoly_account_customizations.agepoly_account_accountant"/>
            </xpath>
            <xpath expr="//field[@name='line_ids']/form/group/field[@name='analytic_account_id']" position="attributes">
                <attribute name="domain">
                    ['|', ('operating_unit_ids', '=', operating_unit_id), ('operating_unit_ids', '=', False)]
                </attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_line_ids']" position="attributes">
                <attribute name="context">
                    {
                    'default_move_type': context.get('default_move_type'),
                    'line_ids': line_ids,
                    'journal_id': journal_id,
                    'default_partner_id': commercial_partner_id,
                    'default_currency_id': currency_id or company_currency_id,
                    'default_operating_unit_id': operating_unit_id}
                </attribute>
            </xpath>
        </field>
    </record>

    <record id="account_move_tier_validation_view_move_form" model="ir.ui.view">
        <field name="name">agepoly.account_move_tier_validation.move.form</field>
        <field name="model">account.move</field>
        <field name="inherit_id" ref="account_move_tier_validation.view_move_form"/>
        <field name="arch" type="xml">
            <xpath expr="//button[@name='request_validation'][1]" position="attributes">
                <attribute name="string">Ask Validation</attribute>         
                <attribute name="class">oe_highlight</attribute>
                <attribute name="attrs">
                    {'invisible': ['|', '|', 
                                    ('state', '!=', 'draft'), 
                                    ('review_ids', '!=', []), 
                                    '&amp;',
                                      ('id', '!=', False),      
                                      ('need_validation', '!=', True)
                                  ]
                    }
                </attribute>
            </xpath>

            <!-- ! need_validation is false on newly created record -->
            <xpath expr="//button[@name='restart_validation'][1]" position="before">
                <button
                        name="validate_tier"
                        string="Validate"
                        attrs="{'invisible': ['|', '|', '|', '|',
                                    ('validated', '=', True), 
                                    ('state', 'not in', ['draft']),
                                    ('rejected', '=', True), 
                                    ('review_ids', '=', []), 
                                    ('can_review', '=', False)
                                    ]}"
                        type="object"
                        class="oe_highlight"
                        icon="fa-thumbs-up"
                    />
            </xpath>

            <xpath expr="//button[@name='restart_validation'][1]" position="attributes">
                <attribute name="string">Back to Draft</attribute>
            </xpath>

            <xpath expr="//button[@name='action_post'][1]" position="attributes">
                <attribute name="attrs">
                    {
                        'invisible': 
                            ['|', '|', '|', '|', '|',
                                ('state', '!=', 'draft'), 
                                ('auto_post', '=', True), 
                                ('move_type', '!=', 'entry'),
                                ('id', '=', False),
                                ('need_validation', '=', True),
                                ('review_ids', '!=', []),
                            ]
                    }
                </attribute>
            </xpath>
            <xpath expr="//button[@name='action_post'][2]" position="attributes">
                <attribute name="attrs">
                    {
                        'invisible': 
                            ['|', '|', '|', '|', '|',
                                ('state', '!=', 'draft'), 
                                ('auto_post', '=', True), 
                                ('move_type', '=', 'entry'),
                                ('id', '=', False),
                                ('need_validation', '=', True),
                                ('review_ids', '!=', []),
                            ]
                    }
                </attribute>
            </xpath>
        </field>
    </record>

    <record id="account_move_tier_validation_view_move_form_sudo_validation" model="ir.ui.view">
        <field name="name">agepoly.account_move_tier_validation.move.form_sudo_validation</field>
        <field name="model">account.move</field>
        <field name="groups_id" eval="[(4, ref('agepoly_account_customizations.agepoly_group_sudo_validation'))]"/>
        <field name="inherit_id" ref="account_move_tier_validation.view_move_form"/>
        <field name="arch" type="xml">
            <xpath expr="//button[@name='restart_validation'][1]" position="after">
                <button
                        name="sudo_validate_tier"
                        string="Force Validate (Sudo)"
                        attrs="{'invisible': ['|', '|', '|',
                                    ('validated', '=', True), 
                                    ('state', 'not in', ['draft']),
                                    ('rejected', '=', True), 
                                    ('review_ids', '=', [])
                                    ]}"
                        type="object"
                        class="btn-warning"
                    />
            </xpath>
        </field>
    </record>

    <record id="agepoly_account_move_account_payment_partner_form_view_ihnerit" model="ir.ui.view">
        <field name="name">agepoly.account_payment_partner.move.form</field>
        <field name="model">account.move</field>
        <field name="inherit_id" ref="account_payment_partner.view_move_form"/>
        <field name="arch" type="xml">
            <!-- do not show payment mode on out invoice (only in) -->
            <xpath expr="//field[@name='payment_mode_id']" position="attributes">
                <attribute name="attrs" eval="
                    {
                        'invisible': [('move_type', 'not in', ['in_invoice', 'in_receipt'])],
                        'readonly': [('state', '!=', 'draft')],
                    }
                "/>
            </xpath>
            <!-- make it editable anytime -->
            <xpath expr="//field[@name='partner_bank_id']" position="attributes">
                <attribute name="attrs">
                    {'required': [('bank_account_required', '=', True)]}
                </attribute>
            </xpath>
            <!-- do not show reference_type -->
            <xpath expr="//field[@name='reference_type']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
        </field>
    </record>

    <!-- hide the delivery address -->
    <record id="agepoly_account_move_sale_account_invoice_form_ihnerit" model="ir.ui.view">      
        <field name="name">agepoly.sale.account_invoice_form</field>
        <field name="model">account.move</field>
        <field name="inherit_id" ref="sale.account_invoice_form"/>
        <field name="arch" type="xml">
            <!-- do not show delivery address -->
            <xpath expr="//field[@name='partner_shipping_id']" position="attributes">
                <attribute name="invisible">1</attribute>
           </xpath>
        </field>
    </record>

    <!--  -->
    <record id="agepoly_account_move_line_form_view_ihnerit" model="ir.ui.view">      
        <field name="name">agepoly.account.move.line.form</field>
        <field name="priority">100</field>
        <field name="model">account.move.line</field>
        <field name="inherit_id" ref="account.view_move_line_form"/>
        <field name="arch" type="xml">
            <xpath expr="//field[@name='analytic_account_id']" position="attributes">
                <attribute name="domain"></attribute>
                <attribute name="attrs"></attribute>
           </xpath>
        </field>
    </record>
    
    <!-- warning when bank account is not set -->
    <!-- create dedicated action for bank/cash in_invoice (bill) -->

    <!-- 1. view for payment in cash ihnerited from the normal view -->
    <record id="move_agepoly_cash_in_invoice_view" model="ir.ui.view">      
        <field name="name">agepoly.move.account_cash_in_invoice</field>
        <field name="model">account.move</field>
        <field name="mode">primary</field> 
        <field name="inherit_id" ref="account.view_move_form"/>
        <field name="arch" type="xml">
            <xpath expr="//field[@name='id']" position="after">
                <field name="payment_order_ok" invisible="1"/>
                <field name="currency_id" invisible="1"/>
            </xpath>

            <xpath expr="//group[@id='header_left_group']" position="replace">
                <group id="header_left_group">
                    <field name="partner_id" widget="res_partner_many2one" string="Vendor"
                        context="{ 'res_partner_search_mode': (context.get('default_move_type', 'entry') in ('out_invoice', 'out_refund', 'out_receipt') and 'customer') or (context.get('default_move_type', 'entry') in ('in_invoice', 'in_refund', 'in_receipt') and 'supplier') or False,
                                'show_address': 1, 'default_is_company': True, 'show_vat': True}"
                        options='{"always_reload": True, "no_quick_create": True}'/>
                    <label for="ref" string="Title" attrs="{'invisible':[('move_type', 'not in', ('in_invoice', 'in_receipt', 'in_refund'))]}"/>
                    <field name="ref" nolabel="1" attrs="{'invisible':[('move_type', 'not in', ('in_invoice', 'in_receipt', 'in_refund'))]}"/>
                    <field name="ref" attrs="{'invisible':[('move_type', 'in', ('in_invoice', 'in_receipt', 'in_refund', 'out_invoice', 'out_refund'))]}"/>
                    <field name="payment_mode_id" readonly="1"/>
                </group>
            </xpath>
            <xpath expr="//group[@id='header_right_group']" position="replace">
                <group id="header_right_group">
                    <field name="date" string="Accounting Date" help="Date of last income"
                        attrs="{'readonly': [('state', '!=', 'draft')]}"/>
                    <field name="journal_id" readonly="1"/>
                    <field name="operating_unit_id" groups="operating_unit.group_multi_operating_unit"/>
                    <field  
                        name="money_requests_ids" 
                        widget="many2many_tags"
                        options="{'no_create': True}"
                    />
                </group>
            </xpath>
        </field>
    </record>

    <!-- 2. ovveride the action for cash paid invoice -->
    <record id="move_agepoly_cash_in_invoice_action" model="ir.actions.act_window">
        <field name="name">Cash Payments to vendors</field>
        <field name="res_model">account.move</field>
        <field name="view_mode">tree,kanban,form</field>
        <field name="view_ids" eval="[(5, 0, 0), 
        (0, 0, {'view_mode': 'tree'}), 
        (0, 0, {'view_mode': 'form', 'view_id': ref('move_agepoly_cash_in_invoice_view')}),                           
        (0, 0, {'view_mode': 'kanban'})]"/>
        <field name="search_view_id" ref="account.view_account_invoice_filter"/>
        <field name="domain" eval="[('move_type', '=', 'in_invoice'), ('payment_mode_id', '=', ref('agepoly_payment_mode_cash_out')),
        ('journal_id', '=', ref('bill_journal'))]"/>
        <field name="context" eval="{
            'is_cash_bill': True, 
            'default_move_type': 'in_invoice', 
            'default_payment_mode_id': ref('agepoly_payment_mode_cash_out'), 
            'default_journal_id': ref('bill_journal'),
            'dont_redirect_to_payments': True,
            'default_invoice_date_due': False,
            'default_invoice_date': False,
            'analytic_account_from_operating_unit': True
        }"/>
        <field name="help" type="html">
            <p class="o_view_nocontent_smiling_face">
              Create a vendor cash receipt
            </p>
            <p>
              Record bill paid in cash.
              </p>
        </field>
    </record>
    <!-- 4. the post method is overrided in models/account_move.py to create payment automtically when needed -->

    <!-- view for bank in invoices-->
    <record id="move_agepoly_bank_in_invoice_view" model="ir.ui.view">      
        <field name="name">agepoly.move.account_bank_in_invoice</field>
        <field name="model">account.move</field>
        <field name="mode">primary</field> 
        <field name="inherit_id" ref="account.view_move_form"/>
        <field name="arch" type="xml">
            <xpath expr="//label[@for='journal_id']" position="attributes">
                <attribute name="groups"></attribute>                
            </xpath>
            <xpath expr="//label[@for='journal_id']" position="attributes">
                <attribute name="invisible">1</attribute>            
            </xpath>
            <xpath expr="//field[@name='journal_id']" position="attributes">
                <attribute name="readonly">1</attribute>
                <attribute name="groups"></attribute>                
            </xpath>
            <xpath expr="//field[@name='payment_mode_id']" position="attributes">
                <attribute name="readonly">0</attribute>
                <attribute name="domain">[('id', 'in', [%(agepoly_payment_mode_bank_out)d, %(agepoly_payment_mode_cornercard)d])]</attribute>
            </xpath>
        </field>
    </record>

    <!-- an action for bank only invoices-->
    <record id="move_agepoly_bank_in_invoice_action" model="ir.actions.act_window">
        <field name="name">Vendor Bill</field>
        <field name="res_model">account.move</field>
        <field name="view_mode">tree,kanban,form</field>
        <field name="view_ids" eval="[(5, 0, 0), 
          (0, 0, {'view_mode': 'tree'}),                           
          (0, 0, {'view_mode': 'kanban'}),
          (0, 0, {'view_mode': 'form', 'view_id': ref('move_agepoly_bank_in_invoice_view')}), 
        ]"/>
        <field name="search_view_id" ref="account.view_account_invoice_filter"/>
        <field name="domain" eval="[('move_type', 'in', ['in_invoice', 'in_refund']), ('payment_mode_id', '!=', ref('agepoly_payment_mode_cash_out')),
        ('journal_id', '=', ref('bill_journal'))]"/>
        <field name="context" eval="{
            'is_cash': False, 
            'default_move_type': 'in_invoice', 
            'default_payment_mode_id': ref('agepoly_payment_mode_bank_out'),
            'default_journal_id': ref('bill_journal'),
            'dont_redirect_to_payments': True,
            'analytic_account_from_operating_unit': True
        }"/>
        <!-- 'default_payment_mode_id': ref('agepoly_payment_mode_bank') -->
        <field name="help" type="html">
            <p class="o_view_nocontent_smiling_face">
              Create a vendor bill create an invoice to be paid by bank transfer or paid credit card AGEPoly
            </p>
        </field>
    </record>

    <!-- view for ndf (treated as in invoices)-->
    <record id="move_agepoly_ndf_view_form" model="ir.ui.view">      
        <field name="name">agepoly.move.account_ndf</field>
        <field name="model">account.move</field>
        <field name="mode">primary</field> 
        <field name="inherit_id" ref="account.view_move_form"/>
        <field name="arch" type="xml">
            <xpath expr="//span[@class='o_form_label']" position="replace">
                <span class="o_form_label">Expense Note</span>
            </xpath> 
            <xpath expr="//label[@for='partner_id']/parent::div" position="replace">
                <label for="partner_id" string="Beneficiary" style="font-weight:bold;"/>
            </xpath> 
            <xpath expr="//field[@name='partner_id']" position="attributes">
                <attribute name="readonly">1</attribute>                   
            </xpath>   
            <xpath expr="//field[@name='payment_reference']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//field[@name='payment_mode_id']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//label[@name='invoice_vendor_bill_id_label']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_vendor_bill_id']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//label[@for='journal_id']" position="attributes">
                <attribute name="groups"></attribute>                
            </xpath>
            <xpath expr="//label[@for='journal_id']" position="attributes">
                <attribute name="invisible">1</attribute>            
            </xpath>
            <xpath expr="//field[@name='journal_id']" position="attributes">
                <attribute name="readonly">1</attribute>
                <attribute name="groups"></attribute>                
            </xpath>
            <xpath expr="//field[@name='invoice_date']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_date']/preceding-sibling::div" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//label[@for='invoice_payment_term_id']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_date_due']/parent::div" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_payment_term_id']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
        </field>
    </record>
    <!-- unlock partner_id for accountant -->
    <record id="move_agepoly_ndf_view_form_unlock_partner" model="ir.ui.view">
            <field name="name">agepoly.move.account_ndf.unlock_partner</field>
            <field name="model">account.move</field>
            <field name="inherit_id" ref="move_agepoly_ndf_view_form" />
            <field name="groups_id" eval="[(6,0, [ref('truffe__any__tresorerie')])]" />
            <field name="arch" type="xml">                
                <xpath expr="//field[@name='partner_id']" position="attributes">
                   <attribute name="readonly">0</attribute>                   
                </xpath>                
            </field>
    </record>   

    <!-- an action for ndf-->
    <record id="move_agepoly_ndf_action" model="ir.actions.act_window">
        <field name="name">Expense Note</field>
        <field name="res_model">account.move</field>
        <field name="view_mode">tree,kanban,form</field>
        <field name="view_ids" eval="[(5, 0, 0), 
          (0, 0, {'view_mode': 'tree'}),                           
          (0, 0, {'view_mode': 'kanban'}),
          (0, 0, {'view_mode': 'form', 'view_id': ref('move_agepoly_ndf_view_form')}), 
        ]"/>        <field name="search_view_id" ref="account.view_account_invoice_filter"/>
        <field name="domain" eval="[('move_type', '=', 'in_invoice'), ('journal_id', '=', ref('ndf_journal'))]"/>
        <field name="context" eval="{
            'is_agepoly_ndf': True, 
            'default_move_type': 'in_invoice',
            'default_payment_mode_id': ref('agepoly_payment_mode_bank_out'), 
            'default_journal_id': ref('ndf_journal'),
            'dont_redirect_to_payments': True,
            'analytic_account_from_operating_unit': True
        }"/>
        <!-- 'default_payment_mode_id': ref('agepoly_payment_mode_bank') -->
        <field name="help" type="html">
            <p class="o_view_nocontent_smiling_face">
             Create an expense note
            </p>
        </field>
    </record>

    <!-- view for out_invoice sent -->
    <record id="move_agepoly_out_invoice_view" model="ir.ui.view">      
        <field name="name">agepoly.move.account_out_invoice</field>
        <field name="model">account.move</field>
        <field name="mode">primary</field> 
        <field name="inherit_id" ref="account.view_move_form"/>
        <field name="arch" type="xml">
            <xpath expr="//label[@for='journal_id']" position="attributes">
                <attribute name="groups"></attribute>                
            </xpath>
            <xpath expr="//label[@for='journal_id']" position="attributes">
                <attribute name="invisible">1</attribute>            
            </xpath>
            <xpath expr="//field[@name='journal_id']" position="attributes">
                <attribute name="readonly">1</attribute>
                <attribute name="groups"></attribute>                
            </xpath>
            <xpath expr="//field[@name='payment_mode_id']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//label[@for='invoice_date']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//field[@name='invoice_date']" position="attributes">
                <attribute name="invisible">1</attribute>
            </xpath>
            <xpath expr="//field[@name='partner_bank_id']" position="attributes">
                <attribute name="readonly">1</attribute>
            </xpath>
        </field>
    </record>

    <!-- action for invoice sent -->
    <record id="move_agepoly_out_invoice_action" model="ir.actions.act_window">
        <field name="name">Customer Invoice</field>
        <field name="res_model">account.move</field>
        <field name="view_mode">tree,kanban,form</field>
        <field name="view_ids" eval="[(5, 0, 0), 
          (0, 0, {'view_mode': 'tree'}),                           
          (0, 0, {'view_mode': 'kanban'}),
          (0, 0, {'view_mode': 'form', 'view_id': ref('move_agepoly_out_invoice_view')}), 
        ]"/>
        <field name="search_view_id" ref="account.view_account_invoice_filter"/>
        <field name="domain" eval="[('move_type', '=', ['out_invoice', 'out_refund']), ('payment_mode_id', '!=', ref('agepoly_payment_mode_cash_out'))]"/>
        <field name="context" eval="{
            'is_cash': False, 
            'default_move_type': 'out_invoice',
            'default_payment_mode_id': ref('agepoly_account_customizations.agepoly_payment_mode_bank_in'),
            'default_partner_bank_id': ref('agepoly_account_customizations.credit_suisse_bank_account'),
            'default_invoice_payment_term_id': ref('account.account_payment_term_2months'),
            'dont_redirect_to_payments': True,
            'analytic_account_from_operating_unit': True
        }"/>
        <field name="help" type="html">
            <p class="o_view_nocontent_smiling_face">
              Create an invoice for our clients
            </p>
        </field>
    </record>

    <!-- view for money received in cash-->
    <record id="move_agepoly_cash_money_in_view" model="ir.ui.view">      
        <field name="name">agepoly.move.account_money_in</field>
        <field name="model">account.move</field>
        <field name="mode">primary</field> 
        <field name="inherit_id" ref="account.view_move_form"/>
        <field name="arch" type="xml">
            <xpath expr="//field[@name='id']" position="after">
                <field name="payment_order_ok" invisible="1"/>
                <field name="currency_id" invisible="1"/>
            </xpath>

            <xpath expr="//group[@id='header_left_group']" position="replace">
                <group id="header_left_group">
                    <field name="partner_id" widget="res_partner_many2one" string="Customer"
                        context="{ 'res_partner_search_mode': (context.get('default_move_type', 'entry') in ('out_invoice', 'out_refund', 'out_receipt') and 'customer') or (context.get('default_move_type', 'entry') in ('in_invoice', 'in_refund', 'in_receipt') and 'supplier') or False,
                                'show_address': 1, 'default_is_company': True, 'show_vat': True}"
                        options='{"always_reload": True, "no_quick_create": True}'/>
                    <label for="ref" string="Title" attrs="{'invisible':[('move_type', 'not in', ('in_invoice', 'in_receipt', 'in_refund'))]}"/>
                    <field name="ref" nolabel="1" attrs="{'invisible':[('move_type', 'not in', ('in_invoice', 'in_receipt', 'in_refund'))]}"/>
                    <field name="ref" attrs="{'invisible':[('move_type', 'in', ('in_invoice', 'in_receipt', 'in_refund', 'out_invoice', 'out_refund'))]}"/>
                    <field name="payment_mode_id" readonly="1"/>
                </group>
            </xpath>
            <xpath expr="//group[@id='header_right_group']" position="replace">
                <group id="header_right_group">
                    <field name="date" string="Date" help="Date of last income"
                        attrs="{'readonly': [('state', '!=', 'draft')]}"/>
                    <field name="journal_id" readonly="1"/>
                    <field name="operating_unit_id" groups="operating_unit.group_multi_operating_unit"/>
                    <field name="money_requests_ids" widget="many2many_tags"/>
                </group>
            </xpath>
        </field>
    </record>

    <!-- an action for money received -->
    <record id="move_agepoly_cash_money_in_action" model="ir.actions.act_window">
        <field name="name">Cash Income from customers</field>
        <field name="res_model">account.move</field>
        <field name="view_mode">tree,kanban,form</field>
        <field name="view_ids" eval="[(5, 0, 0), 
        (0, 0, {'view_mode': 'tree'}), 
        (0, 0, {'view_mode': 'form', 'view_id': ref('move_agepoly_cash_money_in_view')}),                           
        (0, 0, {'view_mode': 'kanban'})]"/>
        <field name="search_view_id" ref="account.view_account_invoice_filter"/>
        <field name="domain" eval="[('move_type', '=', 'out_invoice'), ('payment_mode_id', '=', ref('agepoly_payment_mode_cash_in'))]"/>
        <field name="context" eval="
            {
                'is_cash': True, 
                'default_payment_mode_id': ref('agepoly_payment_mode_cash_in'), 
                'default_move_type': 'out_invoice',
                'analytic_account_from_operating_unit': True
            }
        "/>
        <!--                   'default_partner_id': ref('agepoly_various_customers'),  -->
            <field name="help" type="html">
              <p class="o_view_nocontent_smiling_face">
                Create a cash money in
              </p><p>
                    Money IN
              </p>
            </field>
    </record>

<!-- TODO : 
add client divers record


add security rules

modify partner view for IBAN
Only allow complete edit
Allow add an IBAN if no iban

-->

    <!-- Ma Compta, an action and some views for unit accountants to have meaningfull infos avout their accounting -->
    <!-- We create the view from scratch because it's simple and we do a lot of modification (heavilly inspired from account.view_move_line_tree)-->
    <record id="view_account_move_agepoly_ma_compta_tree" model="ir.ui.view">      
        <field name="name">agepoly.move.account_move_ma_compta_tree</field>
        <field name="model">account.move.line</field>
        <field name="mode">primary</field> 
        <field name="arch" type="xml">
            <tree string="Journal items" create="false" editable="bottom" sample="1">   
                <!-- technical fields -->            
                <field name="company_id" invisible="1" readonly="1"/>
                <field name="debit" invisible="1" readonly="1"/>
                <field name="credit" invisible="1" readonly="1"/>
                <field name="currency_id" invisible="1" readonly="1"/>
                <field name="company_currency_id" invisible="1" readonly="1"/>
                <field name="amount_residual" invisible="1" readonly="1"/>
                <!-- end technical fields -->
                <button name="action_edit_popup" type="object" icon="fa-edit" title="Edit"/>
                <field name="date" optional="show"/>
                <field name="journal_id" invisible="1" readonly="1"/>
                <field name="move_id" optional="show" readonly="1"/>
                <field name="account_id" optional="show" options="{'no_open': True}" groups="account.group_account_readonly" readonly="1"/>
                <field name="partner_id" optional="show" readonly="1"/>
                <field name="name" optional="show"/>
                <field name="ref" optional="show"/>
                <field name="operating_unit_id" optional="hide" readonly="1"/>
                <field name="analytic_account_id" optional="show"/>
                <field name="analytic_tag_ids" widget="many2many_tags" optional="show"/>
                <field name="tax_ids" widget="many2many_tags" width="0.5" optional="show" readonly="1"/>
                <field name="inverse_balance" optional="show" sum="Total" decoration-bf="1" decoration-muted="(credit == 0 and debit == 0)" readonly="1"/>
                <field name="inverse_cumulated_balance" optional="show" readonly="1"/>
                <field name="amount_currency" groups="base.group_multi_currency" optional="hide" readonly="1"/>
                <field name="parent_state" 
                    optional="hide" 
                    widget="badge" 
                    decoration-success="parent_state == 'posted'"
                    decoration-muted="parent_state == 'cancel'"
                    decoration-info="parent_state == 'draft'"
                    readonly="1"/>
            </tree>
        </field>
    </record>

    <!-- we only want a few changes from the original view, so we extend it (in primary mode)-->
    <!-- We create the view from scratch because it's simple and we do a lot of modification (heavilly inspired from account.view_move_line_form)-->
    <record id="view_account_move_agepoly_ma_compta_form" model="ir.ui.view">
        <field name="name">agepoly.move.account_move_ma_compta_form</field>
        <field name="model">account.move.line</field>
        <field name="mode">primary</field> 
        <field name="arch" type="xml">
            <form string="Journal Item" create="false">
                <sheet>
                    <field name="company_id" invisible="1"/>
                    <field name="parent_state" invisible="1"/>
                    <group string="Infos">
                        <field name="name"/>
                        <field name="partner_id"
                            domain="['|', ('parent_id', '=', False), ('is_company', '=', True)]"
                            readonly="1"/>
                    </group>
                    <group string="Accounting Documents">
                        <field name="move_id" readonly="1"/>
                        <field name="statement_id" readonly="1" attrs="{'invisible': [('statement_id','=',False)]}"/>
                    </group>
                    <group string="Amount">
                        <field name="account_id" options="{'no_create': True}" domain="[('company_id', '=', company_id)]" readonly="1"/>
                        <field name="debit" readonly="1"/>
                        <field name="credit" readonly="1"/>
                        <field name="quantity" readonly="1"/>
                    </group>
                    <group string="Analytic">
                        <field name="operating_unit_id" 
                            readonly="1"/>
                        <field name="analytic_account_id"/>
                        <field name="analytic_tag_ids"
                            widget="many2many_tags"/>
                    </group>
                    <group string="Dates">
                        <field name="date" readonly="1" />
                        <field name="date_maturity" readonly="1"/>
                    </group>
                    <group string="Currency" groups="base.group_multi_currency">
                        <field name="currency_id" invisible="1"/>
                        <field name="amount_currency" readonly="1"/>
                    </group>
                    <group string="Taxes" attrs="{'invisible': [('tax_line_id','=',False), ('tax_ids','=',[])]}">
                        <field name="tax_line_id" readonly="1" attrs="{'invisible': [('tax_line_id','=',False)]}"/>
                        <field name="tax_ids" widget="many2many_tags" readonly="1" attrs="{'invisible': [('tax_ids','=',[])]}"/>
                        <field name="tax_exigible" readonly="1"/>
                        <field name="tax_audit"/>
                    </group>
                    <group string="Product" attrs="{'invisible': [('product_id', '=', False)]}">
                        <field name="product_id" readonly="1"/>
                    </group>
                </sheet>
            </form>
        </field>
    </record>

    <record id="action_account_moves_agepoly_ma_compta" model="ir.actions.act_window">
        <field name="name">My Accounting</field>
        <field name="res_model">account.move.line</field>
        <field name="context"> {'search_default_group_by_analytic_group': True, 
                                'search_default_group_by_analytic_account': True, 'search_default_expense_and_revenue': True, 'search_default_current_year_agepoly': True,
                                'search_default_posted': True, 'create': False}</field>
        <field name="domain">[('display_type', 'not in', ('line_section', 'line_note')), ('move_id.state', 'in', ['draft', 'posted'])]</field>
        <field name="view_ids" eval="[(5, 0, 0), 
          (0, 0, {'view_mode': 'tree', 'view_id': ref('view_account_move_agepoly_ma_compta_tree')}),                           
          (0, 0, {'view_mode': 'form', 'view_id': ref('view_account_move_agepoly_ma_compta_form')}), 
          (0, 0, {'view_mode': 'kanban'}),
          (0, 0, {'view_mode': 'pivot'}),
          (0, 0, {'view_mode': 'graph'})
        ]"/>
        <field name="view_mode">tree,pivot,graph,form,kanban</field>
    </record>

    <!-- Account Move Line Search View Amelioration-->
    <!-- We add some filters and grouping possibilities -->
    <record id="view_account_move_line_agepoly_filter" model="ir.ui.view">
        <field name="name">account.move.line.search</field>
        <field name="model">account.move.line</field>
        <field name="inherit_id" ref="account.view_account_move_line_filter"/>
        <field name="arch" type="xml">
            <xpath expr="//field[@name='journal_id']" position="before">
                <field name="analytic_account_id"/>
                <field name="analytic_tag_ids"/>
            </xpath>
            <xpath expr="//filter[@name='unposted']" position="after">
                    <filter string="Expense/Revenue" name="expense_and_revenue" domain="[('account_id.user_type_id', 'in', [%(account.data_account_type_expenses)d, %(account.data_account_type_revenue)d])]" help="Expense and Revenue Lines"/>
                    <filter string="Expense" name="expense" domain="[('account_id.user_type_id', '=', %(account.data_account_type_expenses)d)]" help="Expense Lines"/>
                    <filter string="Revenue" name="revenue" domain="[('account_id.user_type_id', '=', %(account.data_account_type_revenue)d)]" help="Revenue Lines"/>
                    <separator/>
                    <filter string="Paid" name="paid" domain="[('move_id.payment_state', 'in', ('in_payment', 'paid'))]"/>
                    <filter string="Unpaid" name="unpaid" domain="[('move_id.payment_state', 'in', ('partial', 'not_paid'))]"/>
                    <separator/>
                    <filter string="Current accounting year" name="current_year_agepoly" domain="['&amp;',('date','&gt;=',(context_today() - relativedelta(months=7)).strftime('%Y-08-01')),('date','&lt;=',(context_today() + relativedelta(months=5)).strftime('%Y-07-31'))]"/>
                    <filter string="Previous accounting year" name="past_year_agepoly" domain="['&amp;',('date','&gt;=',(context_today() - relativedelta(months=7, years=1)).strftime('%Y-08-01')),('date','&lt;=',(context_today() + relativedelta(months=5, years=-1)).strftime('%Y-07-31'))]"/>
                    <filter string="-2 previous accounting year" name="two_past_year_agepoly" domain="['&amp;',('date','&gt;=',(context_today() - relativedelta(months=31, years=2)).strftime('%Y-08-01')),('date','&lt;=',(context_today() + relativedelta(months=5, years=-2)).strftime('%Y-07-31'))]"/>
                    <separator/>
            </xpath>
            <xpath expr="//filter[@name='group_by_partner']" position="before">
                <separator/>
                <filter string="Analytic Group (Parent)" name="group_by_analytic_parent_group" domain="[]" context="{'group_by': 'analytic_account_parent_group_id'}"/>
                <filter string="Analytic Group" name="group_by_analytic_group" domain="[]" context="{'group_by': 'analytic_account_group_id'}"/>
                <filter string="Analytic Account" name="group_by_analytic_account" domain="[]" context="{'group_by': 'analytic_account_id'}"/>
                <separator/>
            </xpath>
        </field>
    </record>

    <record id="view_invoice_agepoly_status" model="ir.ui.view">
        <field name="name">account.move.agepoly_status</field>
        <field name="model">account.move</field>
        <field name="inherit_id" ref="account.view_invoice_tree"/>
        <field name="arch" type="xml">
            <xpath expr="//field[@name='state']" position = "after">
                <field  name= "agepoly_status"  
                        widget="badge" 
                        decoration-success="agepoly_status == 'validated'"
                        decoration-muted="agepoly_status == 'cancelled'"
                        decoration-info="agepoly_status == 'waiting_cdd_validation' or agepoly_status == 'waiting_unit_validation' or agepoly_status == 'waiting_agepoly_validation'"
                        decoration-warning="agepoly_status == 'to_correct'"/>
            </xpath>
        </field>
    </record>
 
    <record id="view_move_agepoly_status" model="ir.ui.view">
        <field name="name">account.move.agepoly_status</field>
        <field name="model">account.move</field>
        <field name="inherit_id" ref="account.view_move_tree"/>
        <field name="arch" type="xml">
            <xpath expr="//field[@name='state']" position = "after">
                <field  name= "agepoly_status"  
                        widget="badge" 
                        decoration-success="agepoly_status == 'validated'"
                        decoration-muted="agepoly_status == 'cancelled'"
                        decoration-info="agepoly_status == 'waiting_cdd_validation' or agepoly_status == 'waiting_unit_validation' or agepoly_status == 'waiting_agepoly_validation'"
                        decoration-warning="agepoly_status == 'to_correct'"/>
            </xpath>
        </field>
    </record>

    <!-- We add a view to see cash lines only, we use the views of Ma Compta because it's easier -->
    <record id="move_agepoly_jdc_cash_movement" model="ir.actions.act_window">
        <field name="context">{'journal_type': 'cash', 'search_default_group_by_account': 1, 'create':0}</field>
        <field name="name">My Cash</field>
        <field name="res_model">account.move.line</field>
        <field name="domain">[('display_type', 'not in', ('line_section', 'line_note')), ('move_id.journal_id.type', '=', 'cash' ), ('move_id.state', 'in', ['draft', 'posted']), ('account_id.code', '=like', '1002%')
            ]</field>
        <field name="view_ids" eval="[(5, 0, 0), 
          (0, 0, {'view_mode': 'tree', 'view_id': ref('view_account_move_agepoly_ma_compta_tree')}),                           
          (0, 0, {'view_mode': 'form', 'view_id': ref('view_account_move_agepoly_ma_compta_form')}), 
          (0, 0, {'view_mode': 'kanban'}),
          (0, 0, {'view_mode': 'pivot'}),
          (0, 0, {'view_mode': 'graph'})
        ]"/>
        <field name="search_view_id" ref="view_account_move_line_agepoly_filter"/>
        <field name="view_mode">tree,pivot,graph,form,kanban</field>
    </record>

    <!-- Tweak the invoice template for epfl needs -->
    <template id="report_invoice_document_inherit_agepoly_account_customizations" inherit_id="account.report_invoice_document">
        <xpath expr="//div[@name='customer_code']" position="after">
            <div class="col-auto col-3 mw-100 mb-2" t-if="o.partner_id.vat == 'CHE-116.075.613' or o.partner_id.parent_id.vat == 'CHE-116.075.613'" name="epfl_contact">
                <strong>Contact EPFL : </strong>
                <p class="m-0" t-field="o.partner_id.email"/>
            </div>
        </xpath>
    </template>

    <!-- definition of the menus -->
    <menuitem name="Accounting"
        id="agepoly_menu_finance_easy"
        groups="account.group_account_readonly,agepoly_read_accounting"
        web_icon="account,static/description/icon.png"
        sequence="39"/>

        <menuitem id="agepoly_ndf" name="Expense Note" parent="agepoly_menu_finance_easy" action="move_agepoly_ndf_action" sequence="5"/>

        <menuitem id="agepoly_bill" name="Vendor Bill" parent="agepoly_menu_finance_easy" action="move_agepoly_bank_in_invoice_action" sequence="10"/>

        <menuitem id="agepoly_invoice" name="Customer Invoice" parent="agepoly_menu_finance_easy" action="move_agepoly_out_invoice_action" sequence="20"/>

        <menuitem id="agepoly_jdc" name="Cash Journals" parent="agepoly_menu_finance_easy"  sequence="40"/>
            <menuitem id="agepoly_jdc_bill" name="Purchase Receipt" parent="agepoly_jdc" action="move_agepoly_cash_in_invoice_action" sequence="10"/>
            <menuitem id="agepoly_jdc_in" name="Cash Income"  parent="agepoly_jdc" action="move_agepoly_cash_money_in_action" sequence="20"/>
            <menuitem id="menu_easy_money_request" action="account_money_request.action_money_request" name="Money Requests" parent="agepoly_account_customizations.agepoly_jdc" sequence="30" />
            <menuitem id="agepoly_jdc_cash_movement" name="Cash Movements"  parent="agepoly_jdc" action="move_agepoly_jdc_cash_movement" sequence="40"/>

        <menuitem id="agepoly_ma_compta" name="My Accounting" parent="agepoly_menu_finance_easy" action="action_account_moves_agepoly_ma_compta" sequence="50"/>

        <menuitem id="agepoly_mis_builder" name="My Reports" parent="agepoly_menu_finance_easy" action="agepoly_mis_report_my_reports" sequence="60"/>

        <menuitem id="agepoly_my_budget" name="My Budget" parent="agepoly_menu_finance_easy" action="agepoly_mis_budget_by_account_item_my_budget" sequence="70"/>

    <menuitem name="Accounting (advanced)"
        id="account.menu_finance"
        groups="agepoly_advanced_accounting_menu"
        web_icon="account,static/description/icon.png"
        sequence="40"/>
</data>
</odoo>
